//+------------------------------------------------------------------+
//|                                                      BBWNorm.mq4 |
//|              Copyright  2009, Vadim Shumiloff (aka DrShumiloff) |
//|                                                shumiloff@mail.ru |
//+------------------------------------------------------------------+
//#property copyright "Copyright  2009, Vadim Shumiloff (aka DrShumiloff)"
//#property link      "shumiloff@mail.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Gray
#property indicator_width1 2
#property indicator_level1 0.0
#property indicator_level2 30.0

extern int    BandsPeriod       = 16;
extern int    BandsShift        = 0;
extern double BandsDeviations   = 2.0;
extern int    AveragingPeriod   = 3;
extern int    BarsCount         = 100;

SetLevelValue(0,0);
   SetLevelValue(1,38);
   SetLevelValue(2,-38);
   SetLevelStyle(STYLE_DOT,1,DimGray);

double Buffer[];

int init()
  {
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, Buffer);
   IndicatorShortName("BBW%");
   SetIndexLabel(0, "BBW%");
   return(0);
  }

int start()
{
   int i, counted_bars = IndicatorCounted();
   double v0, v1;
   if(Bars <= BandsPeriod) return(0);

   for (i=0; i < BarsCount; i++)
   {
      v0 = iBands(NULL, 0, BandsPeriod, BandsDeviations, BandsShift, PRICE_CLOSE, MODE_UPPER, i) -
                  iBands(NULL, 0, BandsPeriod, BandsDeviations, BandsShift, PRICE_CLOSE, MODE_LOWER, i);
      v1 = GetAverage(i+1);
      Buffer[i] = -((v0 / v1) - 1 ) * 100;
   }
   return(0);
}

double GetAverage(int n)
{
   double sum = 0;
   for (int i=n; i < n + AveragingPeriod; i++)
   {
      sum += iBands(NULL, 0, BandsPeriod, BandsDeviations, BandsShift, PRICE_CLOSE, MODE_UPPER, i) -
                  iBands(NULL, 0, BandsPeriod, BandsDeviations, BandsShift, PRICE_CLOSE, MODE_LOWER, i);
   }
   return(sum / AveragingPeriod);

}